/*
** Insert_Verticaly_Region.c for XQuad in Feuille/
** Insert region verticaly
**
** Copyright (C) 1995-2000 Axene.
** Authors: Stphane Boisson, Antoine Buat, Robin Castanier and Emmanuel Paris.
** Email: xcalibur@axene.org
**
**    This program is free software; you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation; either version 2 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program; if not, write to the Free Software
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**
** Started on  Mon Feb 20 11:56:48 1995 Emmanuel Paris
** Last update Fri Dec 13 18:38:55 1996 Emmanuel Paris
*/

#include "Select_Move_Resize_Cells.h"

void insert_verticaly_region_init();
void insert_verticaly_region_abort();
void insert_verticaly_region_done();
void insert_verticaly_region_to_xy();
void insert_verticaly_region_trace();

void insert_verticaly_region_init(cfeuille,xm,ym)
c_Feuille *cfeuille;
int	  xm;
int	  ym;
{
  int		row;
  DATA(Select_Move_Resize_Cell);
  
  GET_DATA(Select_Move_Resize_Cell);
  
  memcpy(&d(region), cfeuille->cell_region, sizeof(region_t));
  F(cfeuille).GetRowByY(cfeuille, ym, &row);
  d(row) = row;
  
  d(prems) = TRUE;
  d(source) = TRUE;
  
  F(GlobEditBar).certify(GlobEditBar->Edit, GlobEditBar);
  insert_verticaly_region_to_xy(cfeuille, xm, ym);  
  
  d(AutoScroll) = (c_AutoScroll *)NEW(c_AutoScroll)
    (cfeuille->X_info.display, 0, 0,
     0, cfeuille->sheet_height, NULL, cfeuille->ScrollBarV,
     eventlook_Select_Move_Resize_Cell, cfeuille);
}

void insert_verticaly_region_abort(cfeuille)
c_Feuille *cfeuille;
{ 
  DATA(Select_Move_Resize_Cell);
  
  GET_DATA(Select_Move_Resize_Cell);
  
  if (d(AutoScroll))
    {
      DELETE(c_AutoScroll)(d(AutoScroll));
      d(AutoScroll) = (c_AutoScroll *)NULL;
    }  
  
  insert_verticaly_region_trace(cfeuille, TRUE);
  d(source)=FALSE;  d(source) = FALSE;
}

void insert_verticaly_region_done(cfeuille)
c_Feuille *cfeuille;
{  
  int	incy;
  region_t region;
  DATA(Select_Move_Resize_Cell);
  
  GET_DATA(Select_Move_Resize_Cell);

  if (d(AutoScroll))
    {
      DELETE(c_AutoScroll)(d(AutoScroll));
      d(AutoScroll) = (c_AutoScroll *)NULL;
    }
  insert_verticaly_region_trace(cfeuille);
  
  if (cfeuille->cell_region->y_min == d(region).y_min)
    {
      region.y_min = cfeuille->cell_region->y_max + 1;
      region.y_max = d(region).y_max;
    }
  else
  {
    incy = cfeuille->cell_region->y_min - d(region).y_min;
    d(region).y_min += incy;
    d(region).y_max += incy;
    region.y_min = d(region).y_min;
    region.y_max = cfeuille->cell_region->y_min - 1 + incy;
  }
  region.x_min = cfeuille->cell_region->x_min;
  region.x_max = cfeuille->cell_region->x_max;
  F(cfeuille->moteur).insert_zone_row(cfeuille->moteur, &region);
  
  region.y_max = ROW_MAX;
  F(cfeuille).RefreshRegion(cfeuille, &region, Xq_CELL);
  F(cfeuille).RefreshRegion(cfeuille, &region, Xq_ROW);
  F(cfeuille).DeselectRegion(cfeuille,Xq_ORIGIN,TRUE);
  F(cfeuille).SelectRegion(cfeuille, d(region).x_min, d(region).y_min,
			   d(region).x_max, d(region).y_max, Xq_CELL, TRUE);
  F(GlobEditBar).refresh_cell(GlobEditBar, cfeuille);
  d(source)=FALSE;
}

void insert_verticaly_region_to_xy(cfeuille,xm,ym)
c_Feuille *cfeuille;
int	xm;
int	ym;
{ 
  int	row;
  DATA(Select_Move_Resize_Cell);
  
  GET_DATA(Select_Move_Resize_Cell);

  if (xm < 0 || xm >= cfeuille->origin_width)
    xm = 1;
  if (ym < 0)
    ym = 0;
  if (ym >= cfeuille->sheet_height)
    ym = cfeuille->sheet_height - 1;
  
  if (F(cfeuille).GetRowByY(cfeuille, ym, &row) )
    {    
      if (row < cfeuille->cell_region->y_max && 
	  row > cfeuille->cell_region->y_min)
	{
	  if (row < d(row))
	    row = cfeuille->cell_region->y_max;
	  if (row > d(row))
	    row = cfeuille->cell_region->y_min;
	}
      
      if (row!=d(row) || d(prems))
	{
	  d(row) = row;
	
	  if (d(prems))
	    {
	      if (row >= cfeuille->cell_region->y_max)
		{
		  d(region).y_max = row;
		  d(region).y_min = cfeuille->cell_region->y_min;
		}
	      if (row <= cfeuille->cell_region->y_min)
		{
		  d(region).y_min = row;
		  d(region).y_max = cfeuille->cell_region->y_max;
		}
	      insert_verticaly_region_trace(cfeuille);
	      d(prems) = FALSE;
	      return;
	    }

	  insert_verticaly_region_trace(cfeuille);
	  if (row >= cfeuille->cell_region->y_max)
	    {
	      d(region).y_max = row;
	      d(region).y_min = cfeuille->cell_region->y_min;
	    } 
	  if (row <= cfeuille->cell_region->y_min)
	    {
	      d(region).y_min = row;
	      d(region).y_max = cfeuille->cell_region->y_max;
	    }
	  insert_verticaly_region_trace(cfeuille);
	}
    }
}

void insert_verticaly_region_trace(cfeuille)
c_Feuille *cfeuille;
{  
  Display	*display;
  Window		window;
  GC		gc;
  int		x1, y1, x2, y2;
  DATA(Select_Move_Resize_Cell);
  
  GET_DATA(Select_Move_Resize_Cell);
  display=cfeuille->X_info.display;
  window=cfeuille->X_info.window;
  gc=cfeuille->X_info.gc_contour;
  
  x1 = get_column_pos(cfeuille, d(region).x_min);
  y1 = get_row_pos(cfeuille, d(region).y_min);
  x2 = get_column_pos(cfeuille, d(region).x_max+1);
  y2 = get_row_pos(cfeuille, d(region).y_max+1);
  XDrawRectangle(display, window, gc, x1, y1, x2-x1, y2-y1);
}
