/*
** mac_encoding.h for Xclamation, XQuad, XAllWrite and XMayday in Global/
** mac_encoding table
**
** Copyright (C) 1994-2000 Axene.
** Authors: Stphane Boisson, Antoine Buat, Robin Castanier and Emmanuel Paris.
** Email: xcalibur@axene.org
**
**    This program is free software; you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation; either version 2 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program; if not, write to the Free Software
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**
** Started on  Wed Feb 22 16:59:27 1995 Emmanuel Paris
** Last update Sun Mar 15 15:24:08 1998 Emmanuel Paris
*/

#ifndef _mac_encoding_h_
#define _mac_encoding_h_

#include "encoding_sym.h"

/* MAC  ->  Iso Latin 1 */
static unsigned char mac_encoding[256] = {
  XcS_unknow,
  XcS_Eth,
  XcS_eth,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_Yacute,
  XcS_yacute,
  XcS_unknow,
  XcS_unknow,
  XcS_Thorn,
  XcS_thorn,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_onehalf,
  XcS_onequarter,
  XcS_onesuperior,
  XcS_threequarters,
  XcS_threesuperior,
  XcS_twosuperior,
  XcS_brokenbar,
  XcS_minus,
  XcS_multiply,
  XcS_unknow,
  XcS_unknow,
  XcS_space,
  XcS_exclam,
  XcS_quotedbl,
  XcS_numbersign,
  XcS_dollar,
  XcS_percent,
  XcS_ampersand,
  XcS_quoteright,
  XcS_parenleft,
  XcS_parenright,
  XcS_asterisk,
  XcS_plus,
  XcS_comma,
  XcS_hyphen,
  XcS_period,
  XcS_slash,
  XcS_zero,
  XcS_one,
  XcS_two,
  XcS_three,
  XcS_four,
  XcS_five,
  XcS_six,
  XcS_seven,
  XcS_eight,
  XcS_nine,
  XcS_colon,
  XcS_semicolon,
  XcS_less,
  XcS_equal,
  XcS_greater,
  XcS_question,
  XcS_at,
  XcS_A,
  XcS_B,
  XcS_C,
  XcS_D,
  XcS_E,
  XcS_F,
  XcS_G,
  XcS_H,
  XcS_I,
  XcS_J,
  XcS_K,
  XcS_L,
  XcS_M,
  XcS_N,
  XcS_O,
  XcS_P,
  XcS_Q,
  XcS_R,
  XcS_S,
  XcS_T,
  XcS_U,
  XcS_V,
  XcS_W,
  XcS_X,
  XcS_Y,
  XcS_Z,
  XcS_bracketleft,
  XcS_backslash,
  XcS_bracketright,
  XcS_asciicircum,
  XcS_underscore,
  XcS_grave,
  XcS_a,
  XcS_b,
  XcS_c,
  XcS_d,
  XcS_e,
  XcS_f,
  XcS_g,
  XcS_h,
  XcS_i,
  XcS_j,
  XcS_k,
  XcS_l,
  XcS_m,
  XcS_n,
  XcS_o,
  XcS_p,
  XcS_q,
  XcS_r,
  XcS_s,
  XcS_t,
  XcS_u,
  XcS_v,
  XcS_w,
  XcS_x,
  XcS_y,
  XcS_z,
  XcS_braceleft,
  XcS_bar,
  XcS_braceright,
  XcS_asciitilde,
  XcS_unknow,
  XcS_Adieresis,
  XcS_Aring,
  XcS_Ccedilla,
  XcS_Eacute,
  XcS_Ntilde,
  XcS_Odieresis,
  XcS_Udieresis,
  XcS_aacute,
  XcS_agrave,
  XcS_acircumflex,
  XcS_adieresis,
  XcS_atilde,
  XcS_aring,
  XcS_ccedilla,
  XcS_eacute,
  XcS_egrave,
  XcS_ecircumflex,
  XcS_edieresis,
  XcS_iacute,
  XcS_igrave,
  XcS_icircumflex,
  XcS_idieresis,
  XcS_ntilde,
  XcS_oacute,
  XcS_ograve,
  XcS_ocircumflex,
  XcS_odieresis,
  XcS_otilde,
  XcS_uacute,
  XcS_ugrave,
  XcS_ucircumflex,
  XcS_udieresis,
  XcS_unknow,
  XcS_degree,
  XcS_cent,
  XcS_sterling,
  XcS_section,
  XcS_unknow,
  XcS_paragraph,
  XcS_germandbls,
  XcS_registered,
  XcS_copyright,
  XcS_unknow,
  XcS_acute,
  XcS_dieresis,
  XcS_unknow,
  XcS_AE,
  XcS_Oslash,
  XcS_unknow,
  XcS_plusminus,
  XcS_unknow,
  XcS_unknow,
  XcS_yen,
  XcS_mu,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_ordfeminine,
  XcS_ordmasculine,
  XcS_unknow,
  XcS_ae,
  XcS_oslash,
  XcS_questiondown,
  XcS_exclamdown,
  XcS_logicalnot,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_guillemotleft,
  XcS_guillemotright,
  XcS_unknow,
  XcS_nobreakspace,
  XcS_Agrave,
  XcS_Atilde,
  XcS_Otilde,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_guillemotleft,
  XcS_guillemotright,
  XcS_quoteleft,
  XcS_quoteright,
  XcS_divide,
  XcS_unknow,
  XcS_ydieresis,
  XcS_unknow,
  XcS_unknow,
  XcS_currency,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_periodcentered,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_Acircumflex,
  XcS_Ecircumflex,
  XcS_Aacute,
  XcS_Edieresis,
  XcS_Egrave,
  XcS_Iacute,
  XcS_Icircumflex,
  XcS_Idieresis,
  XcS_Igrave,
  XcS_Oacute,
  XcS_Ocircumflex,
  XcS_unknow,
  XcS_Ograve,
  XcS_Uacute,
  XcS_Ucircumflex,
  XcS_Ugrave,
  XcS_unknow,
  XcS_asciicircum,
  XcS_asciitilde,
  XcS_macron,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_cedilla,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow
};

/* Iso Latin 1  ->  MAC */

static unsigned char to_mac_encoding[256] = {
   0, 202, 202, 202, 202, 202, 202, 202,   8,   9, 202, 202,  12,  13, 202,
 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,  27, 202, 202,
 202, 202,  32,  33,  34,  35,  36,  37,  38,  39,  40,  41,  42,  43,  44,
  28,  46,  47,  48,  49,  50,  51,  52,  53,  54,  55,  56,  57,  58,  59,
  60,  61,  62,  63,  64,  65,  66,  67,  68,  69,  70,  71,  72,  73,  74,
  75,  76,  77,  78,  79,  80,  81,  82,  83,  84,  85,  86,  87,  88,  89,
  90,  91,  92,  93,  94,  95,  96,  97,  98,  99, 100, 101, 102, 103, 104,
 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119,
 120, 121, 122, 123, 124, 125, 126, 202, 202, 202, 202, 202, 202, 202, 202,
 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 193, 162, 163, 219,
 180,  27, 164, 172, 169, 187, 199, 194,  45, 168, 248, 161, 177,  26,  25,
 171, 181, 166, 225, 252,  23, 188, 200,  22,  21,  24, 192, 203, 231, 229,
 204, 128, 129, 174, 130, 233, 131, 230, 232, 237, 234, 235, 236,   1, 132,
 241, 238, 239, 205, 133,  29, 175, 244, 242, 243, 134,   7,  11, 167, 136,
 135, 137, 139, 138, 140, 190, 141, 143, 142, 144, 145, 147, 146, 148, 149,
   2, 150, 152, 151, 153, 155, 154, 214, 191, 157, 156, 158, 159,   8,  12,
 216
};
#endif /* _mac_encoding_h_ */
