/*
** dos_encoding.h for Xclamation, XQuad, XAllWrite and XMayday in Global/
**
** Copyright (C) 1994-2000 Axene.
** Authors: Stphane Boisson, Antoine Buat, Robin Castanier and Emmanuel Paris.
** Email: xcalibur@axene.org
**
**    This program is free software; you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation; either version 2 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program; if not, write to the Free Software
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**
** Started on  Mon Jul 17 14:15:33 1995 Emmanuel Paris
** Last update Sun Mar 15 15:23:23 1998 Emmanuel Paris
*/

#ifndef _dos_encoding_h_
#define _dos_encoding_h_

#include "encoding_sym.h"

/* DOS  ->  Iso Latin 1 */
static unsigned char dos_encoding[256] = {
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_space,
  XcS_exclam,
  XcS_quotedbl,
  XcS_numbersign,
  XcS_dollar,
  XcS_percent,
  XcS_ampersand,
  XcS_quoteright,
  XcS_parenleft,
  XcS_parenright,
  XcS_asterisk,
  XcS_plus,
  XcS_comma,
  XcS_minus,
  XcS_period,
  XcS_slash,
  XcS_zero,
  XcS_one,
  XcS_two,
  XcS_three,
  XcS_four,
  XcS_five,
  XcS_six,
  XcS_seven,
  XcS_eight,
  XcS_nine,
  XcS_colon,
  XcS_semicolon,
  XcS_less,
  XcS_equal,
  XcS_greater,
  XcS_question,
  XcS_at,
  XcS_A,
  XcS_B,
  XcS_C,
  XcS_D,
  XcS_E,
  XcS_F,
  XcS_G,
  XcS_H,
  XcS_I,
  XcS_J,
  XcS_K,
  XcS_L,
  XcS_M,
  XcS_N,
  XcS_O,
  XcS_P,
  XcS_Q,
  XcS_R,
  XcS_S,
  XcS_T,
  XcS_U,
  XcS_V,
  XcS_W,
  XcS_X,
  XcS_Y,
  XcS_Z,
  XcS_bracketleft,
  XcS_backslash,
  XcS_bracketright,
  XcS_asciicircum,
  XcS_underscore,
  XcS_quoteleft,
  XcS_a,
  XcS_b,
  XcS_c,
  XcS_d,
  XcS_e,
  XcS_f,
  XcS_g,
  XcS_h,
  XcS_i,
  XcS_j,
  XcS_k,
  XcS_l,
  XcS_m,
  XcS_n,
  XcS_o,
  XcS_p,
  XcS_q,
  XcS_r,
  XcS_s,
  XcS_t,
  XcS_u,
  XcS_v,
  XcS_w,
  XcS_x,
  XcS_y,
  XcS_z,
  XcS_braceleft,
  XcS_brokenbar,
  XcS_braceright,
  XcS_asciitilde,
  XcS_unknow,	/* 127 */
  XcS_Ccedilla,
  XcS_udieresis,
  XcS_eacute,
  XcS_acircumflex,
  XcS_adieresis,
  XcS_agrave,
  XcS_aring,
  XcS_ccedilla,
  XcS_ecircumflex,
  XcS_edieresis,
  XcS_egrave,
  XcS_idieresis,
  XcS_icircumflex,
  XcS_igrave,
  XcS_Adieresis,
  XcS_Aring,
  XcS_Eacute,
  XcS_ae,
  XcS_AE,
  XcS_ocircumflex,
  XcS_odieresis,
  XcS_ograve,
  XcS_ucircumflex,
  XcS_ugrave,
  XcS_ydieresis,
  XcS_Odieresis,
  XcS_Udieresis,
  XcS_cent,
  XcS_sterling,
  XcS_yen,
  XcS_unknow,
  XcS_unknow,
  XcS_aacute,
  XcS_iacute,
  XcS_oacute,
  XcS_uacute,
  XcS_ntilde,
  XcS_Ntilde,
  XcS_ordfeminine,
  XcS_ordmasculine,
  XcS_questiondown,
  XcS_unknow,
  XcS_macron,
  XcS_onehalf,
  XcS_onequarter,
  XcS_exclamdown,
  XcS_guillemotleft,
  XcS_guillemotright,
  XcS_nobreakspace,
  XcS_unknow,
  XcS_unknow,
  XcS_bar,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_ssharp,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_mu,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_oslash,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_plusminus,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_unknow,
  XcS_divide,
  XcS_unknow,
  XcS_degree,
  XcS_unknow,
  XcS_periodcentered,
  XcS_unknow,
  XcS_unknow,
  XcS_twosuperior,
  XcS_unknow,
  XcS_unknow
};

/* Iso Latin 1  -> DOS */
static unsigned char to_dos_encoding[256] = {
    0, 255, 255, 255, 255, 255, 255, 255,   8,   9,  10, 255,  12,  13, 255,
  255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,  27, 255, 255,
  255, 255,  32,  33,  34,  35,  36,  37,  38,  39,  40,  41,  42,  43,  44,
   45,  46,  47,  48,  49,  50,  51,  52,  53,  54,  55,  56,  57,  58,  59,
   60,  61,  62,  63,  64,  65,  66,  67,  68,  69,  70,  71,  72,  73,  74,
   75,  76,  77,  78,  79,  80,  81,  82,  83,  84,  85,  86,  87,  88,  89,
   90,  91,  92,  93,  94,  95,  96,  97,  98,  99, 100, 101, 102, 103, 104,
  105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119,
  120, 121, 122, 123, 179, 125, 126, 255, 255, 255, 255, 255, 255, 255, 255,
  255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
  255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 173, 155, 156, 255,
  157, 124, 255, 255, 255, 166, 174, 255, 255, 255, 170, 248, 241, 253, 255,
  255, 230, 255, 250, 255, 255, 167, 175, 172, 171, 255, 168, 255, 255, 255,
  255, 142, 143, 146, 128, 255, 144, 255, 255, 255, 255, 255, 255, 255, 165,
  255, 255, 255, 255, 153, 255, 255, 255, 255, 255, 154, 255, 255, 225, 133,
  160, 131, 255, 132, 134, 145, 135, 138, 130, 136, 137, 141, 161, 140, 139,
  255, 164, 149, 162, 147, 255, 148, 246, 237, 151, 163, 150, 129, 255, 255,
  152
};

#endif /* _dos_encoding_h_ */
